
#ifndef MAIN_H
#define MAIN_H
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
//vȌ
enum {
	STATE_INIT  = 0x01,
	STATE_RESET,
	STATE_SELECT,
	STATE_GAME_INPUT,
	STATE_GAME_CHK,
	STATE_GAME_END,
};


typedef struct {
	u8* pHead;
	u8* pCur;
	s32 size;
	u16 maxNum;
	u16 num;
} ST_SELECT;

//---------------------------------------------------------------------------
EWRAM_CODE void StateInit();
EWRAM_CODE void StateReset();
EWRAM_CODE void StateSelect();
EWRAM_CODE void StateGameInput();
EWRAM_CODE void StateGameChk();
EWRAM_CODE void StateGameEnd();

EWRAM_CODE void InitWS();
EWRAM_CODE void InitLib();
EWRAM_CODE void InitKey();
EWRAM_CODE void InitIRQ();
EWRAM_CODE void InitFont();
EWRAM_CODE void InitSprite();


//----
EWRAM_CODE void SelectInit();
EWRAM_CODE void SelectLoad();

EWRAM_CODE void SelectProcMenu();
EWRAM_CODE void SelectProcBoard();
EWRAM_CODE void SelectProcSolve();

EWRAM_CODE void SelectDrawMsgChoice();
EWRAM_CODE void SelectDrawMsgSolve();
EWRAM_CODE void SelectDrawMsgEnd();
EWRAM_CODE void SelectDrawMsgClear();


//----
EWRAM_CODE void SystemError(char* msg1, char* msg2);


#ifdef __cplusplus
}
#endif
#endif
