
#ifndef __SUDOKU_H__
#define __SUDOKU_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define CELL_MAX_CNT			(9*9)
#define CELL_LEN_X				9
#define CELL_LEN_Y				9
#define CELL_CX					16
#define CELL_CY					16
#define CELL_SX					48
#define CELL_SY					12

//---------------------------------------------------------------------------
//Z̃^Cv
enum {
	TYPE_CONST,
	TYPE_VAR,
};

//---------------------------------------------------------------------------
typedef struct {
	u8  type;
	s16 num;
} ST_CELL;

typedef struct {
	s16  num;
	u16  cnt;
	bool flag[1+9];
} ST_SOLVE_CELL;

typedef struct {
	ST_CELL       cell[CELL_LEN_X][CELL_LEN_Y];
	ST_SOLVE_CELL solveCell[CELL_LEN_X][CELL_LEN_Y];
} ST_SUDOKU;

//---------------------------------------------------------------------------
EWRAM_CODE void SudokuInit();
EWRAM_CODE bool SudokuLoadStage(u8* pData);

EWRAM_CODE void SudokuProcSolve();

EWRAM_CODE void SudokuSetCell(u16 x, u16 y, u16 num);
EWRAM_CODE bool SudokuSetSolveCell(u16 x, u16 y);
EWRAM_CODE void SudokuSetSolveFlagClear(ST_SOLVE_CELL* p);
EWRAM_CODE void SudokuSetSolveFlagVert(ST_SOLVE_CELL* p, u16 x);
EWRAM_CODE void SudokuSetSolveFlagHoriz(ST_SOLVE_CELL* p, u16 y);
EWRAM_CODE void SudokuSetSolveFlagArea(ST_SOLVE_CELL* p, u16 x, u16 y);

EWRAM_CODE void SudokuDrawCellAll();
EWRAM_CODE void SudokuDrawCell(u16 x, u16 y);
EWRAM_CODE void SudokuDrawBg();


EWRAM_CODE void SudokuChgCell(u16 x, u16 y, s16 add);

EWRAM_CODE bool SudokuIsGameEnd();


#ifdef __cplusplus
}
#endif
#endif
